#ifndef _KILIB_PATH_H_
#define _KILIB_PATH_H_
#include "types.h"
#include "string.h"
#ifndef __ccdoc__
namespace ki {
#endif


	
//=========================================================================
//@{ @pkg ki.StdLib //@}
//@{
//	t@C
//
//	{Iɂ͕łAɃt@CƂĈƂɕ֗
//	NXłBÔݎoƂgq̂ݎoƂA
//	ĂƂFXB
//@}
//=========================================================================

class Path : public String
{
public:

	Path() {}

	//@{ ʂPath̃Rs[ //@}
	Path( const Path&   s )              : String( s ){}
	Path( const String& s )              : String( s ){}
	Path( const TCHAR*  s, long siz=-1 ) : String( s, siz ){}

	//@{ P //@}
	Path& operator=( const Path&   s )
		{ return static_cast<Path&>(String::operator=(s)); }
	Path& operator=( const String& s )
		{ return static_cast<Path&>(String::operator=(s)); }
	Path& operator=( const TCHAR*  s )
		{ return static_cast<Path&>(String::operator=(s)); }

	//@{ Z //@}
	Path& operator+=( const Path&   s )
		{ return static_cast<Path&>(String::operator+=(s)); }
	Path& operator+=( const String& s )
		{ return static_cast<Path&>(String::operator+=(s)); }
	Path& operator+=( const TCHAR*  s )
		{ return static_cast<Path&>(String::operator+=(s)); }
	Path& operator+=( TCHAR c )
		{ return static_cast<Path&>(String::operator+=(c)); }

	//@{ pX擾ď //@}
	explicit Path( int nPATH, bool bs=true )
		{ BeSpecialPath( nPATH, bs ); }

	//@{ pX擾 //@}
	Path& BeSpecialPath( int nPATH, bool bs=true );

	//@{ pXwp萔 //@}
	enum { Win=0x1787, Sys, Tmp, Exe, Cur, ExeName,
			Snd=CSIDL_SENDTO, Dsk=CSIDL_DESKTOPDIRECTORY };

	//@{ ŌɃobNXbV(true)/Ȃ(false) //@}
	Path& BeBackSlash( bool add );

	//@{ fBNĝ //@}
	Path& BeDirOnly();

	//@{ ZpX //@}
	Path& BeShortStyle();

public:

	//@{ t@Cǂ //@}
	bool isFile() const;

	//@{ fBNgǂ //@}
	bool isDirectory() const;

	//@{ ݂邩ǂBisFile() || isDirectory() //@}
	bool exist() const;
};



//-------------------------------------------------------------------------

inline bool Path::isFile() const
	{ return 0==(::GetFileAttributes(c_str())&FILE_ATTRIBUTE_DIRECTORY); }

inline bool Path::isDirectory() const
	{ DWORD x=::GetFileAttributes(c_str());
	  return x!=0xffffffff && (x&FILE_ATTRIBUTE_DIRECTORY)!=0; }

inline bool Path::exist() const
	{ return 0xffffffff != ::GetFileAttributes(c_str()); }



//=========================================================================

}      // namespace ki
#endif // _KILIB_PATH_H_
